// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from weight_scale_interfaces:msg/Weight.idl
// generated code does not contain a copyright notice

#ifndef WEIGHT_SCALE_INTERFACES__MSG__DETAIL__WEIGHT__TRAITS_HPP_
#define WEIGHT_SCALE_INTERFACES__MSG__DETAIL__WEIGHT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "weight_scale_interfaces/msg/detail/weight__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace weight_scale_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const Weight & msg,
  std::ostream & out)
{
  out << "{";
  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
    out << ", ";
  }

  // member: stable
  {
    out << "stable: ";
    rosidl_generator_traits::value_to_yaml(msg.stable, out);
    out << ", ";
  }

  // member: overload
  {
    out << "overload: ";
    rosidl_generator_traits::value_to_yaml(msg.overload, out);
    out << ", ";
  }

  // member: weight
  {
    out << "weight: ";
    rosidl_generator_traits::value_to_yaml(msg.weight, out);
    out << ", ";
  }

  // member: unit
  {
    out << "unit: ";
    rosidl_generator_traits::value_to_yaml(msg.unit, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Weight & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }

  // member: stable
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stable: ";
    rosidl_generator_traits::value_to_yaml(msg.stable, out);
    out << "\n";
  }

  // member: overload
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "overload: ";
    rosidl_generator_traits::value_to_yaml(msg.overload, out);
    out << "\n";
  }

  // member: weight
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "weight: ";
    rosidl_generator_traits::value_to_yaml(msg.weight, out);
    out << "\n";
  }

  // member: unit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "unit: ";
    rosidl_generator_traits::value_to_yaml(msg.unit, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Weight & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace weight_scale_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use weight_scale_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const weight_scale_interfaces::msg::Weight & msg,
  std::ostream & out, size_t indentation = 0)
{
  weight_scale_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use weight_scale_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const weight_scale_interfaces::msg::Weight & msg)
{
  return weight_scale_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<weight_scale_interfaces::msg::Weight>()
{
  return "weight_scale_interfaces::msg::Weight";
}

template<>
inline const char * name<weight_scale_interfaces::msg::Weight>()
{
  return "weight_scale_interfaces/msg/Weight";
}

template<>
struct has_fixed_size<weight_scale_interfaces::msg::Weight>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<weight_scale_interfaces::msg::Weight>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<weight_scale_interfaces::msg::Weight>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // WEIGHT_SCALE_INTERFACES__MSG__DETAIL__WEIGHT__TRAITS_HPP_
