// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from weight_scale_interfaces:action/SetZero.idl
// generated code does not contain a copyright notice

#ifndef WEIGHT_SCALE_INTERFACES__ACTION__DETAIL__SET_ZERO__TRAITS_HPP_
#define WEIGHT_SCALE_INTERFACES__ACTION__DETAIL__SET_ZERO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "weight_scale_interfaces/action/detail/set_zero__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace weight_scale_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const SetZero_Goal & msg,
  std::ostream & out)
{
  out << "{";
  // member: timeout
  {
    out << "timeout: ";
    rosidl_generator_traits::value_to_yaml(msg.timeout, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetZero_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: timeout
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timeout: ";
    rosidl_generator_traits::value_to_yaml(msg.timeout, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetZero_Goal & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace weight_scale_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use weight_scale_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const weight_scale_interfaces::action::SetZero_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  weight_scale_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use weight_scale_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const weight_scale_interfaces::action::SetZero_Goal & msg)
{
  return weight_scale_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<weight_scale_interfaces::action::SetZero_Goal>()
{
  return "weight_scale_interfaces::action::SetZero_Goal";
}

template<>
inline const char * name<weight_scale_interfaces::action::SetZero_Goal>()
{
  return "weight_scale_interfaces/action/SetZero_Goal";
}

template<>
struct has_fixed_size<weight_scale_interfaces::action::SetZero_Goal>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<weight_scale_interfaces::action::SetZero_Goal>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<weight_scale_interfaces::action::SetZero_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace weight_scale_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const SetZero_Result & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetZero_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetZero_Result & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace weight_scale_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use weight_scale_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const weight_scale_interfaces::action::SetZero_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  weight_scale_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use weight_scale_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const weight_scale_interfaces::action::SetZero_Result & msg)
{
  return weight_scale_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<weight_scale_interfaces::action::SetZero_Result>()
{
  return "weight_scale_interfaces::action::SetZero_Result";
}

template<>
inline const char * name<weight_scale_interfaces::action::SetZero_Result>()
{
  return "weight_scale_interfaces/action/SetZero_Result";
}

template<>
struct has_fixed_size<weight_scale_interfaces::action::SetZero_Result>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<weight_scale_interfaces::action::SetZero_Result>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<weight_scale_interfaces::action::SetZero_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'weight'
#include "weight_scale_interfaces/msg/detail/weight__traits.hpp"

namespace weight_scale_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const SetZero_Feedback & msg,
  std::ostream & out)
{
  out << "{";
  // member: weight
  {
    out << "weight: ";
    to_flow_style_yaml(msg.weight, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetZero_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: weight
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "weight:\n";
    to_block_style_yaml(msg.weight, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetZero_Feedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace weight_scale_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use weight_scale_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const weight_scale_interfaces::action::SetZero_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  weight_scale_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use weight_scale_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const weight_scale_interfaces::action::SetZero_Feedback & msg)
{
  return weight_scale_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<weight_scale_interfaces::action::SetZero_Feedback>()
{
  return "weight_scale_interfaces::action::SetZero_Feedback";
}

template<>
inline const char * name<weight_scale_interfaces::action::SetZero_Feedback>()
{
  return "weight_scale_interfaces/action/SetZero_Feedback";
}

template<>
struct has_fixed_size<weight_scale_interfaces::action::SetZero_Feedback>
  : std::integral_constant<bool, has_fixed_size<weight_scale_interfaces::msg::Weight>::value> {};

template<>
struct has_bounded_size<weight_scale_interfaces::action::SetZero_Feedback>
  : std::integral_constant<bool, has_bounded_size<weight_scale_interfaces::msg::Weight>::value> {};

template<>
struct is_message<weight_scale_interfaces::action::SetZero_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "weight_scale_interfaces/action/detail/set_zero__traits.hpp"

namespace weight_scale_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const SetZero_SendGoal_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetZero_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetZero_SendGoal_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace weight_scale_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use weight_scale_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const weight_scale_interfaces::action::SetZero_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  weight_scale_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use weight_scale_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const weight_scale_interfaces::action::SetZero_SendGoal_Request & msg)
{
  return weight_scale_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<weight_scale_interfaces::action::SetZero_SendGoal_Request>()
{
  return "weight_scale_interfaces::action::SetZero_SendGoal_Request";
}

template<>
inline const char * name<weight_scale_interfaces::action::SetZero_SendGoal_Request>()
{
  return "weight_scale_interfaces/action/SetZero_SendGoal_Request";
}

template<>
struct has_fixed_size<weight_scale_interfaces::action::SetZero_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value && has_fixed_size<weight_scale_interfaces::action::SetZero_Goal>::value> {};

template<>
struct has_bounded_size<weight_scale_interfaces::action::SetZero_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value && has_bounded_size<weight_scale_interfaces::action::SetZero_Goal>::value> {};

template<>
struct is_message<weight_scale_interfaces::action::SetZero_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace weight_scale_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const SetZero_SendGoal_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: accepted
  {
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetZero_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetZero_SendGoal_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace weight_scale_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use weight_scale_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const weight_scale_interfaces::action::SetZero_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  weight_scale_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use weight_scale_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const weight_scale_interfaces::action::SetZero_SendGoal_Response & msg)
{
  return weight_scale_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<weight_scale_interfaces::action::SetZero_SendGoal_Response>()
{
  return "weight_scale_interfaces::action::SetZero_SendGoal_Response";
}

template<>
inline const char * name<weight_scale_interfaces::action::SetZero_SendGoal_Response>()
{
  return "weight_scale_interfaces/action/SetZero_SendGoal_Response";
}

template<>
struct has_fixed_size<weight_scale_interfaces::action::SetZero_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<weight_scale_interfaces::action::SetZero_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<weight_scale_interfaces::action::SetZero_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<weight_scale_interfaces::action::SetZero_SendGoal>()
{
  return "weight_scale_interfaces::action::SetZero_SendGoal";
}

template<>
inline const char * name<weight_scale_interfaces::action::SetZero_SendGoal>()
{
  return "weight_scale_interfaces/action/SetZero_SendGoal";
}

template<>
struct has_fixed_size<weight_scale_interfaces::action::SetZero_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<weight_scale_interfaces::action::SetZero_SendGoal_Request>::value &&
    has_fixed_size<weight_scale_interfaces::action::SetZero_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<weight_scale_interfaces::action::SetZero_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<weight_scale_interfaces::action::SetZero_SendGoal_Request>::value &&
    has_bounded_size<weight_scale_interfaces::action::SetZero_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<weight_scale_interfaces::action::SetZero_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<weight_scale_interfaces::action::SetZero_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<weight_scale_interfaces::action::SetZero_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace weight_scale_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const SetZero_GetResult_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetZero_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetZero_GetResult_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace weight_scale_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use weight_scale_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const weight_scale_interfaces::action::SetZero_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  weight_scale_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use weight_scale_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const weight_scale_interfaces::action::SetZero_GetResult_Request & msg)
{
  return weight_scale_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<weight_scale_interfaces::action::SetZero_GetResult_Request>()
{
  return "weight_scale_interfaces::action::SetZero_GetResult_Request";
}

template<>
inline const char * name<weight_scale_interfaces::action::SetZero_GetResult_Request>()
{
  return "weight_scale_interfaces/action/SetZero_GetResult_Request";
}

template<>
struct has_fixed_size<weight_scale_interfaces::action::SetZero_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<weight_scale_interfaces::action::SetZero_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<weight_scale_interfaces::action::SetZero_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "weight_scale_interfaces/action/detail/set_zero__traits.hpp"

namespace weight_scale_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const SetZero_GetResult_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: result
  {
    out << "result: ";
    to_flow_style_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetZero_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result:\n";
    to_block_style_yaml(msg.result, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetZero_GetResult_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace weight_scale_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use weight_scale_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const weight_scale_interfaces::action::SetZero_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  weight_scale_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use weight_scale_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const weight_scale_interfaces::action::SetZero_GetResult_Response & msg)
{
  return weight_scale_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<weight_scale_interfaces::action::SetZero_GetResult_Response>()
{
  return "weight_scale_interfaces::action::SetZero_GetResult_Response";
}

template<>
inline const char * name<weight_scale_interfaces::action::SetZero_GetResult_Response>()
{
  return "weight_scale_interfaces/action/SetZero_GetResult_Response";
}

template<>
struct has_fixed_size<weight_scale_interfaces::action::SetZero_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<weight_scale_interfaces::action::SetZero_Result>::value> {};

template<>
struct has_bounded_size<weight_scale_interfaces::action::SetZero_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<weight_scale_interfaces::action::SetZero_Result>::value> {};

template<>
struct is_message<weight_scale_interfaces::action::SetZero_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<weight_scale_interfaces::action::SetZero_GetResult>()
{
  return "weight_scale_interfaces::action::SetZero_GetResult";
}

template<>
inline const char * name<weight_scale_interfaces::action::SetZero_GetResult>()
{
  return "weight_scale_interfaces/action/SetZero_GetResult";
}

template<>
struct has_fixed_size<weight_scale_interfaces::action::SetZero_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<weight_scale_interfaces::action::SetZero_GetResult_Request>::value &&
    has_fixed_size<weight_scale_interfaces::action::SetZero_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<weight_scale_interfaces::action::SetZero_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<weight_scale_interfaces::action::SetZero_GetResult_Request>::value &&
    has_bounded_size<weight_scale_interfaces::action::SetZero_GetResult_Response>::value
  >
{
};

template<>
struct is_service<weight_scale_interfaces::action::SetZero_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<weight_scale_interfaces::action::SetZero_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<weight_scale_interfaces::action::SetZero_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "weight_scale_interfaces/action/detail/set_zero__traits.hpp"

namespace weight_scale_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const SetZero_FeedbackMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: feedback
  {
    out << "feedback: ";
    to_flow_style_yaml(msg.feedback, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetZero_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feedback:\n";
    to_block_style_yaml(msg.feedback, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetZero_FeedbackMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace weight_scale_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use weight_scale_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const weight_scale_interfaces::action::SetZero_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  weight_scale_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use weight_scale_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const weight_scale_interfaces::action::SetZero_FeedbackMessage & msg)
{
  return weight_scale_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<weight_scale_interfaces::action::SetZero_FeedbackMessage>()
{
  return "weight_scale_interfaces::action::SetZero_FeedbackMessage";
}

template<>
inline const char * name<weight_scale_interfaces::action::SetZero_FeedbackMessage>()
{
  return "weight_scale_interfaces/action/SetZero_FeedbackMessage";
}

template<>
struct has_fixed_size<weight_scale_interfaces::action::SetZero_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value && has_fixed_size<weight_scale_interfaces::action::SetZero_Feedback>::value> {};

template<>
struct has_bounded_size<weight_scale_interfaces::action::SetZero_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value && has_bounded_size<weight_scale_interfaces::action::SetZero_Feedback>::value> {};

template<>
struct is_message<weight_scale_interfaces::action::SetZero_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
struct is_action<weight_scale_interfaces::action::SetZero>
  : std::true_type
{
};

template<>
struct is_action_goal<weight_scale_interfaces::action::SetZero_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<weight_scale_interfaces::action::SetZero_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<weight_scale_interfaces::action::SetZero_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // WEIGHT_SCALE_INTERFACES__ACTION__DETAIL__SET_ZERO__TRAITS_HPP_
